/**
 * @(#)TableExampleApplet.java
 *
 *
 * @author Gabor Nemeth
 * @version 1.00 2008/9/11
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import java.util.*;
import javax.swing.table.*;


public class TableExample extends JFrame implements ActionListener, ItemListener {
  
    //private Vector<Vector<String>> data;                  /* row data */
    private Vector<String> colNames;              /* column names */
    JScrollPane scrollPane;                       /* a scrollable panel for the table */
    TextField nameField;                          /* input field for names */
    Choice ageList;                           /* input field for names */
    Choice weightList;                        /* input field for names */
    JButton addButton;                            /* button for add new record to the table */
    JPanel mainPanel;
    JPanel inputPanel;                            /* panel for input fields and button */
    JTable table;     
    DefaultTableModel tableModel;
  
  
    String name, age, weight;
  
  
    public TableExample() {
      super("Table Example");
      
      this.setSize( 400, 250 );
      
      //DefaultTableModel tableModel = new DefaultTableModel( 0, 3 );
      
      /* initialize data */
      //data = new Vector<Vector<String>>();
      /* add three rows to the data */
      //data.add(new Vector<String>());
      //data.add(new Vector<String>());
      //data.add(new Vector<String>());
      
      /* filling the rows */
      //data[0].add("Kate");     /* name */
      //data[0].add("" + 25);    /* age (converted to string) */
      //data[0].add("" + 56);    /* weight (converted to string) */
      
      //data[1].add("Julia");     /* name */
      //data[1].add("" + 54);    /* age (converted to string) */
      //data[1].add("" + 67);    /* weight (converted to string) */
      
      //data[2].add("Peter");     /* name */
      //data[2].add("" + 37);    /* age (converted to string) */
      //data[2].add("" + 87);    /* weight (converted to string) */
      
      /* filling column names */
      colNames = new Vector<String>();
      colNames.add("Name");
      colNames.add("Age");
      colNames.add("Weight");
      
      mainPanel = new JPanel();
      mainPanel.setLayout( new GridLayout(2,1));
      inputPanel = new JPanel();
      inputPanel.setLayout( new GridLayout(4,2) );
      
      tableModel = new DefaultTableModel( colNames, 0 );
      
      table = new JTable( tableModel );
      scrollPane = new JScrollPane(table);
      //scrollPane.add(table);
      
      nameField = new TextField( 20 );
      ageList = new Choice();
      weightList = new Choice();
      addButton = new JButton( "Add" );
      
      for ( int i = 0; i < 150; i++ ) {
        ageList.add( "" + i );
      }
      for ( int i = 1; i < 300; i+=2 ) {
        weightList.add( "" + i );
      }
      
      nameField.setText( "" );
      ageList.select( 20 );
      weightList.select( 60 );
     
      inputPanel.add( new Label("Name:") );
      inputPanel.add( nameField );
      inputPanel.add( new Label("Age:") );
      inputPanel.add( ageList );
      inputPanel.add( new Label("Weight:") );
      inputPanel.add( weightList );
      inputPanel.add( new Label() );
      inputPanel.add( addButton );
      
      mainPanel.add(scrollPane);
      mainPanel.add(inputPanel);
      
      ageList.addItemListener(this);
      weightList.addItemListener(this);
      addButton.addActionListener(this);
      
      this.getContentPane().add(mainPanel);
      this.setVisible(true);
    }
    
    public void actionPerformed(ActionEvent e) {
      if ( e.getSource().equals(addButton) ) {
        //Vector<String> row = new Vector<String>();
        
        age = ageList.getSelectedItem();
        weight = weightList.getSelectedItem();
        
        String[] row = {nameField.getText(), age, weight};
        //row.add( nameField.getText() );
        //row.add( age );
        //row.add( weight );
        
        //data.add( row );
        
        tableModel.addRow( row );
        
        nameField.setText( "" );
        ageList.select( 20 );
        weightList.select( 60 );
       
        
        repaint();
      }
    }
    
    public void itemStateChanged(ItemEvent e) {
      if ( e.getSource().equals( ageList ) ) {
        age = ageList.getSelectedItem();
      }
      if ( e.getSource().equals( weightList ) ) {
        weight = weightList.getSelectedItem();
      }
    }
    
    
    public static void main(String[] args) {
      TableExample frame = new TableExample();
      frame.setVisible(true);
      
      // this is an implementation of window listener
      // the program will be stopped if you close the main frame
      WindowListener listener = new WindowAdapter() {
        public void windowClosing(WindowEvent we) {
          System.exit(0);
        }
      };
      frame.addWindowListener(listener);
    }

    
}